Longest subarray whose sum <= k
Longest subarray whose sum
Given an array
of
numbers and a key
, find the longest subarray of
for which the subarray sum is less than or equal to
.
In the following we describe an algorithm with time complexity
.
Algorithm LONGESTSUBARRAY(
,
)
Longest_subarray_k_improved.cpp LongestSubarrayK.java
Longest subarray whose sum
Given an array
In the following we describe an algorithm with time complexity
Algorithm LONGESTSUBARRAY(
Input: An array
and a real number 
Output: A pair of indices
, maximizing
, subject to ![\sum_{t = i}^j A[t] \leq k \sum_{t = i}^j A[t] \leq k](https://lh3.googleusercontent.com/blogger_img_proxy/AEn0k_vYNhFnablphA3P_e3HAKFHLfizqQfxDAHUQGCBAUPWAow0cIzB-xB27T7X-GvG-svdBxd8VuHiR3doWr2OJlh6ac-PdFeEg7D8I8WLjhQMUOXducmrt-0JKT5Q8DEFJxL2uen1ginnARjuWFWmeLTqffBVTgS0f5suEZK3VK1_cWwUQA=s0-d)
1. Compute the array
of partial sums, where
is the prefix sum of the first
numbers in
.
.
2.
3.
4.
5. for
down to 0
if![S[i] < {\rm smallest} S[i] < {\rm smallest}](https://lh3.googleusercontent.com/blogger_img_proxy/AEn0k_sXCra1ua-PRcn_5uWOzt8P48tDJ0BHnl-16AuH2hBegZ4M_VZcAKiUeLijEafj3aJ4dQ-UzBvL_a2GUca4xHuI05TIPiih1-oii4vq1OozJBbZIodrU-4KRdPbQ6m6uL555PWtaPzvndivE_Aj5hdJM8uo3TiC2RFWZw=s0-d)
![M \leftarrow M \cup \{(S[i], i)\} M \leftarrow M \cup \{(S[i], i)\}](https://lh3.googleusercontent.com/blogger_img_proxy/AEn0k_sBs8DSiF9ZwvmYTlGKpN8D5DZ1omz5T3jUy9aOBvENSF7ZFe6YvWhgzSdSU7yMEKCN7ZWtu3PdHv0pF9pjojJr1IZpGNWr84kG_4cqTmtjLDWk73veUqP9BWkTrRikVaHbGRFDQWROeBTTBUAvxUSsE6xmoCJOwW1eSa6Lyaj9oqkutpVQjzwpgF4=s0-d)
![{\rm smallest} \leftarrow S[i] {\rm smallest} \leftarrow S[i]](https://lh3.googleusercontent.com/blogger_img_proxy/AEn0k_uu0caEHmHDTvjFo1ucjJF5ABNhIoGTjVqk12h7Xpp6f9qweSmsUFUp2L96EcrQGXgT0MzIsVuSM98d_8t0WVshMlOw5vIx9c_UWtgyKN-Jc68BqSc1-5VAhHgJW3HkVACcDBnox_qdBGHyCvVrX46p3vLnJPNzdovsVYManAC0yYA5=s0-d)
6.
7. for
up to 
if![S[i] > {\rm current} S[i] > {\rm current}](https://lh3.googleusercontent.com/blogger_img_proxy/AEn0k_sfLM7nDSVUJ4hevb9En3Lt8TG7iNlCEnxJclfzAQIo7O0aOSw4Z2L1WINN47TOAoCcWEXe286QIM1s0ELAElUHg8b6E08ekIaMQU0xKiIXi_5gJWn7XdHH6ZiH2ZgvM9xQ_wXpOUrlReHZ5akA2j2ZQ8WYOetO93iy=s0-d)
Use binary search to look for the rightmost element
in
such that
. If such an element exists, update
to
if 
![{\rm current} \leftarrow S[i] {\rm current} \leftarrow S[i]](https://lh3.googleusercontent.com/blogger_img_proxy/AEn0k_tc6gm1STSNfS8Fn4kIG0RuLrq4UUxVIcT7Rr31EEXj9vqrt17AflJqPK6WVsd0jO0hAlDLct94XiL6vXtH5natl4CI_QUfTTu9xMDtqkKHbftP8PmP4SHQ9RcHs7KR_5wh97R5CL8JryZpHWWIew2jaHFd2mcDvrmTVakQViEIvAil=s0-d)
8. return
Find the longest subarray whose sum <= kOutput: A pair of indices
1. Compute the array
2.
3.
4.
5. for
if
6.
7. for
if
Use binary search to look for the rightmost element
8. return
Longest_subarray_k_improved.cpp LongestSubarrayK.java
public static Pair<Integer, Integer> findLongestSubarrayLessEqualK(
List<Integer> A, int k) {
// Build the prefix sum according to A.
List<Integer> prefixSum = new ArrayList<>();
int sum = 0;
for (int a : A) {
sum += a;
prefixSum.add(sum);
}
List<Integer> minPrefixSum = new ArrayList<>(prefixSum);
for (int i = minPrefixSum.size() - 2; i >= 0; --i) {
minPrefixSum.set(i,
Math.min(minPrefixSum.get(i), minPrefixSum.get(i + 1)));
}
Pair<Integer, Integer> arrIdx = new Pair<>(0,
upperBound2(minPrefixSum, k) - 1);
for (int i = 0; i < prefixSum.size(); ++i) {
int idx = upperBound2(minPrefixSum, k + prefixSum.get(i)) - 1;
if (idx - i - 1 > arrIdx.getSecond() - arrIdx.getFirst()) {
arrIdx = new Pair<>(i + 1, idx);
}
}
return arrIdx;
}
Correctness of the Algorithm
The key is to observe the following two facts.
Claim: (1) If two indices
satisfies that
, then
cannot appear in an optimum solution; (2) If two indices
satisfies that
, then
cannot appear in an optimum solution.
Proof: For any index
,
, note that the subarray sum of
is less than the subarray sum of
, and the length of the subarray $A[i..r']$ is greater than the length of the subarray
(although both length might be negative, but the statement still holds). Therefore,
is preferable over
. This is also the reason why we compute the strictly increasing sequence of
.
The second statement follows a similar reasoning.
Claim: (1) If two indices
Proof: For any index
The second statement follows a similar reasoning.
Time Complexity and Space Complexity
Step 1, computing the prefix sums, takes
time. Step 4, computing the array
, takes
time. Step 7 takes
time as each iteration takes
time.
Please read full article from Longest subarray whose sum <= kStep 1, computing the prefix sums, takes